const defaultConfig = require('./node_modules/@wordpress/scripts/config/webpack.config.js');

const {
	getWebpackEntryPoints,
} = require('./node_modules/@wordpress/scripts/utils');

// Plugins.
const RemoveEmptyScriptsPlugin = require('webpack-remove-empty-scripts');

// Utilities.
const path = require('path');

// Add any a new entry point by extending the webpack config.
module.exports = {
	...defaultConfig,
	...{
		entry: {
			...getWebpackEntryPoints(),
			'js/app': path.resolve(process.cwd(), 'src/js', 'app.js'),
			'js/admin': path.resolve(process.cwd(), 'src/js/admin', 'admin.js'),
			'css/app': path.resolve(process.cwd(), 'src/scss', 'style.scss'),
			'css/admin': path.resolve(process.cwd(), 'src/scss/admin', 'style.scss'),
		},
		plugins: [
			// Include WP's plugin config.
			...defaultConfig.plugins,

			// Removes the empty `.js` files generated by webpack but
			// sets it after WP has generated its `*.asset.php` file.
			new RemoveEmptyScriptsPlugin({
				stage: RemoveEmptyScriptsPlugin.STAGE_AFTER_PROCESS_PLUGINS,
			}),
		],
		module: {
			...defaultConfig.module,
			rules: [
				...defaultConfig.module.rules,
				//move svg files into separate folder from scss
				{
					test: /\.svg$/,
					issuer: /\.(pc|sc|sa|c)ss$/,
					type: 'asset/resource',
					generator: {
						filename: 'svg/[name].[hash:8][ext]',
					},
				},
			],
		},
	},
};
